#
#*===================================================================
#*
#* Licensed Materials - Property of IBM
#*
#* CA12
#*
#* (c) Copyright IBM Corp. 2014  All Rights Reserved
#*
#* US Government Users Restricted Rights - Use, duplication or
#* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#*
#*===================================================================
#
import maestro
import glob
import os
import logging

import sys

utilpath = maestro.node['scriptdir'] + '/WAS/CICSAPP'
if not utilpath in sys.path:
    sys.path.append(utilpath)
#endif
import update_app

logger = logging.getLogger("CICSAPP/configure.py")

host = maestro.xparms['host']
port = maestro.xparms['port']
serviceName = maestro.xparms['serviceName']
archive_file = maestro.role['archive_file']

#Update the Web/Enterprise Application with the new endpoint information
update_app.updateApp(archive_file, serviceName, host, port)

#Open the firewall to the endpoint
maestro.firewall.open_tcpout(dest=host, dport=port)
