#!/usr/bin/python

#
#*===================================================================
#*
#* Licensed Materials - Property of IBM
#*
#* CA12
#*
#* (c) Copyright IBM Corp. 2014  All Rights Reserved
#*
#* US Government Users Restricted Rights - Use, duplication or
#* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#*
#*===================================================================
#

import sys
import urllib2
from xml.dom import minidom

hostname = sys.argv[1]
port = sys.argv[2]
cicsPlex = sys.argv[3]
base64string = sys.argv[4]
application = sys.argv[5]
appversion = sys.argv[6]
platform = sys.argv[7]
binding = sys.argv[8]
bindingVer = sys.argv[9]

status = 'UNKNOWN'

try:
    request = urllib2.Request('http://'+hostname+':'+port+'/CICSSystemManagement/CICSPlatform/'+cicsPlex)
    authheader = 'Basic %s' % base64string
    request.add_header('Authorization', authheader)
    u = urllib2.urlopen(request)
    platformData = u.read()
    platformDef = ''
    
    platformDoc = minidom.parseString(platformData)
    platformList = platformDoc.getElementsByTagName('cicsplatform')
    platformFound = False
    for platformResource in platformList:
        platformName = str(platformResource.getAttribute('platform'))
        if platformName == platform:
            #Found the platform, now check the status which could be ACTIVE, INACTIVE or PARTIAL
            #The application could still be ENABLED in a PARTIAL platform.
            #I guess it's our choice whether we continue to check application or error due to state of platform
            platformStatus = str(platformResource.getAttribute('status'))
            if platformStatus == 'INACTIVE':
                status = 'CRITICAL'
            #endif
            platformFound = True
            platformDef = str(platformResource.getAttribute('platdef'))
            platformHome = str(platformResource.getAttribute('plathome'))
            break
        #endif
    #endfor
    if not platformFound:
        status = 'CRITICAL'
    #endif
    
    request = urllib2.Request('http://'+hostname+':'+port+'/CICSSystemManagement/CICSApplication/'+cicsPlex)
    request.add_header('Authorization', authheader)
    u = urllib2.urlopen(request)
    data = u.read();

    doc = minidom.parseString(data)

    applicationDefns = doc.getElementsByTagName('cicsapplication')
    applicationFound = False
    for applicationDefn in applicationDefns:
        applicationName = str(applicationDefn.getAttribute('application'))
        appPlatformDef = str(applicationDefn.getAttribute('platdef'))
        version = str(applicationDefn.getAttribute('majorversion')) + '.' + str(applicationDefn.getAttribute('minorversion')) + '.' + str(applicationDefn.getAttribute('microversion'))
        applicationBinddir = str(applicationDefn.getAttribute('binddir'))
        if platformHome.endswith('/'):
            requiredBinddir = platformHome + 'bindings/' + binding + '_' + bindingVer
        else:
            requiredBinddir = platformHome + '/bindings/' + binding + '_' + bindingVer
        #endif 
        if applicationName == application and platformDef == appPlatformDef and appversion == version:
            applicationFound = True
            if applicationBinddir == (requiredBinddir + '/') or applicationBinddir == requiredBinddir:
                appstatus = str(applicationDefn.getAttribute('enablestatus'))
                if(appstatus == "ENABLED"):
                    status = 'NORMAL'
                else:
                    status = 'CRITICAL'
                #endif
            else:
                status = 'CRITICAL'
            #endif
            break
        #endif
    #endfor
    if not applicationFound:
        status = 'CRITICAL'
except urllib2.URLError:
    status = 'UNKNOWN'

jsonOutput = '{"version": 2,"category":["CICS_Application"],"content": [{"CICS_Application": {"app_status":"'+status+'"}}]}'

print jsonOutput
